<%--
  此部分为文件的创建相关注释，表明该文件是通过 IntelliJ IDEA 创建的，创建者是 jhu，创建时间为 2020 年 10 月 19 日 22 时 56 分，同时说明了修改该模板的相关设置操作的路径信息。
--%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <title>图书热销榜单</title>
    <%-- 包含公共的头部页面（header.jsp），这里面通常会放置页面通用的样式表引入、脚本引入或者一些页面头部布局相关的内容，以实现代码复用。 --%>
    <%@include file="/pages/common/header.jsp"%>
</head>
<body>
<div id="header">
    <img class="logo_img" alt="" src="static/img/logo1.jpg" >
    <span class="wel_word">图书热销榜单</span>
    <div>
        <span>欢迎光临书店</span>
        <a href="index.jsp">返回</a>
    </div>
</div>

<div id="main">
    <table style="height: 350px">
        <tr>
            <td>排名</td>
            <td>书名</td>
            <td>价格</td>
            <td>作者</td>
            <td style="color: red">销量</td>
        </tr>
        <%-- 在 JSP 页面中嵌入 Java 代码片段，定义一个整型变量 i 并初始化为 1，这个变量将用于记录图书的排名。 --%>
        <%int i=1;%>
        <c:forEach items="${requestScope.page.items}" var="book">
            <tr>
                <td><%=i++%></td>
                <td>${book.name}</td>
                <td>${book.price}</td>
                <td>${book.author}</td>
                <td style="color: red">${book.sales}</td>
            </tr>
            <%-- 使用 JSTL 的 c:forEach 标签来遍历 requestScope 中 page 对象的 items 属性（通常这里是一个包含图书信息的集合），每次循环将集合中的一个元素赋值给变量 book，然后在表格行（tr）中展示对应图书的各项信息，包括通过表达式输出的排名（通过 Java 代码片段中的 i 变量来展示，并且每次循环自增 1）以及图书的名称、价格、作者和销量（通过 EL 表达式 ${book.name} 等获取相应属性值进行展示）。 --%>
        </c:forEach>

        <tr>
            <td></td>
            <td></td>
            <td></td>
            <td></td>
            <td></td>
            <td></td>
        </tr>
    </table>
</div>

<%@include file="/pages/common/footer.jsp"%>
</body>
</html>